#include <ESP8266WiFi.h>
#define MAX_SRV_CLIENTS 3   // Максимальное количество одновременных подключений (не более 5)
 
const char *ssid = "AMPERMARKET.KZ";  // AMPERMARKET.KZ следует заменить на SSID вашей Wi-Fi точки доступа
const char *password = "123456";      // Здесь следует указать пароль вашей точки доступа
 
WiFiServer server(8266);              // Ваш порт, доступный диапазон портов: 0-65535
WiFiClient serverClients[MAX_SRV_CLIENTS];


#define water_PIN 4                   // Порт платы ESP8266 для подключения датчика воды

#define tem_PIN 5                     // Порт платы ESP8266 для подключения датчика температуры и влажности DHT11

int n=0;
WiFiClient client;

#define uv_PIN A0


int b,bb,bbb,bbbb,bbbbb,bbbbbb,bbbbbbb;

 
void setup()
{
    Serial.begin(115200);
    delay(10);
    pinMode(16, OUTPUT);
    digitalWrite(16, 0);
    WiFi.begin(ssid, password);
 
    while (WiFi.status() != WL_CONNECTED)
    {
        delay(500);
    }
     Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());         // WiFi.LocalIP() возвращает IP адрес платы ESP8266 в сети Wi-Fi

    server.begin();
    server.setNoDelay(true);

     pinMode(water_PIN, INPUT);
     pinMode(uv_PIN, INPUT);     
}
 
void loop()
{
int temp;               // значение температуры
int humi;               // значение влажности
int tol;
int j;
unsigned int loopCnt;
int chr[40] = {0}; 
unsigned long time1;
  bgn:
  delay(2000);
// 20 мс выдается сигнал низкого уровня, а затем 40 мкс выдается сигнал высокого уровня
  pinMode(tem_PIN,OUTPUT);
  digitalWrite(tem_PIN,LOW);
  delay(20);
  digitalWrite(tem_PIN,HIGH);
  delayMicroseconds(40);
  digitalWrite(tem_PIN,LOW);
  pinMode(tem_PIN,INPUT);
// Ожидание ответного согнала высокого уровня
  loopCnt=10000;
  while(digitalRead(tem_PIN) != HIGH)
  {
    if(loopCnt-- == 0)
    {
// Если по прошествии 10 секунд не поступило высокого сигнала, то выводится соответствующее сообщение и процесс начинается заново
      Serial.println("HIGH");
      goto bgn;
    }
  }
// Ожидание ответного сигнала низкого уровня
  loopCnt=30000;
  while(digitalRead(tem_PIN) != LOW)
  {
    if(loopCnt-- == 0)
    {
// Если по прошествии 30 секунд не поступило высокого сигнала, то выводится соответствующее сообщение и процесс начинается заново
      Serial.println("LOW");
      goto bgn;
    }
  }
// Чтение битов 1—40 входящего массива данных
    for(int i=0;i<40;i++)
  {
    while(digitalRead(tem_PIN) == LOW)
    {}
// Как только на вход поступает высокий сигнал, с помощью переменной time1 засекается этот момент времени
    time1 = micros();
    while(digitalRead(tem_PIN) == HIGH)
    {}
// Когда высокий сигнал на входе сменяется низким, происзводится подсчет прошедшего времени
// Если длительность высокого сигнала превышает 50 мкс, то в текущую ячейку массива записывается "1", в противном случае — "0"
    if (micros() - time1  >50)
    {
      chr[i]=1;
    }else{
      chr[i]=0;
    }
  }
    
// Получение значения влажности из полученного массива данных (биты 1—8)
humi=chr[0]*128+chr[1]*64+chr[2]*32+chr[3]*16+chr[4]*8+chr[5]*4+chr[6]*2+chr[7];
    
// Получение значения температуры из полученного массива данных (биты 17—24)
temp=chr[16]*128+chr[17]*64+chr[18]*32+chr[19]*16+chr[20]*8+chr[21]*4+chr[22]*2+chr[23];

// Проверка данных (биты 33—40)
//tol=chr[32]*128+chr[33]*64+chr[34]*32+chr[35]*16+chr[36]*8+chr[37]*4+chr[38]*2+chr[39];

//  Вывод в монитор серийного порта значений температуры и влажности
  String str1="mode=up&apikey=674c0a5616458361&data={ck001002";
  str1+=temp;
  str1+=".";
  str1+=humi;
  str1+="}\r\n";
  //client.print(str1);
  //Serial.print(str1);
  Serial.print("temp:");
  Serial.println(temp);
  bb=temp;
  Serial.print("humi:");
  Serial.println(humi);
  bbb=humi;
    
    static long previousMillis = 0;
    static int currstate = 0;
  
    if (millis() - previousMillis > 200)
    {
        previousMillis = millis();
        currstate = 1 - currstate;
        digitalWrite(16, currstate);
        b=analogRead(A0);
        Serial.println(b);         
        //Serial.println(bb);
    }
 
    uint8_t i;
    if (server.hasClient())
    {
        for (i = 0; i < MAX_SRV_CLIENTS; i++)
        {
            if (!serverClients[i] || !serverClients[i].connected())
            {
                if (serverClients[i]) serverClients[i].stop();
                serverClients[i] = server.available();
                continue;
            }
 
        }
        WiFiClient serverClient = server.available();
        serverClient.stop();
    }
    for (i = 0; i < MAX_SRV_CLIENTS; i++)
    {
        if (serverClients[i] && serverClients[i].connected())
        {
            digitalWrite(16, 0);    // Есть соединение, включается светодиод
 
            if (serverClients[i].available())
            {
                while (serverClients[i].available()) 
                    Serial.write(serverClients[i].read());
            }
        }
    }
        size_t s=8;
        uint8_t buff[s];
        
        buff[0]='R';
         
       if(digitalRead(water_PIN)==HIGH)
       {
        buff[1]='1';
        }
        else
        {
          buff[1]='0';
        }      
         
        if(b>450)
        {
          buff[2]='6';
        }
        else
        {
          buff[2]='9';
        }
                
        bbbb=bbb/10;
        if(bbbb==0)
        {
          buff[3]='A';
        }
        if(bbbb==1)
        {
          buff[3]='B';
        }
        if(bbbb==2)
        {
          buff[3]='C';
        }
        if(bbbb==3)
        {
          buff[3]='D';  
        }
        if(bbbb==4)
        {
          buff[3]='E';
        }
        if(bbbb==5)
        {
           buff[3]='F';
        }
        if(bbbb==6)
        {
          buff[3]='G';
        }
        if(bbbb==7)
        {
          buff[3]='H';
        }
        if(bbbb==8)
        {
          buff[3]='I';
        }   
        if(bbbb==9)
        {
          buff[3]='J';
        }             
        bbbbb=bbb%10;
        if(bbbbb==0)
        {
          buff[4]='a';
        }
        if(bbbbb==1)
        {
          buff[4]='b';
        }
        if(bbbbb==2)
        {
          buff[4]='c';    
        }
        if(bbbbb==3)
        {
          buff[4]='d';  
        }
        if(bbbbb==4)
        {
          buff[4]='e';  
        } 
        if(bbbbb==5)
        {
          buff[4]='f';  
        }               
        if(bbbbb==6)
        {
          buff[4]='g';  
        }        
        if(bbbbb==7)
        {
          buff[4]='h';  
        }    
        if(bbbbb==8)
        {
          buff[4]='i';  
        } 
        if(bbbbb==9)
        {
          buff[4]='j';  
        }
        
        bbbbb=bb/10;
        if(bbbbb==0)
        {
          buff[5]='K';
        }
        if(bbbbb==1)
        {
          buff[5]='L';
        }
        if(bbbbb==2)
        {
          buff[5]='M';
        }
        if(bbbbb==3)
        {
          buff[5]='N';  
        }
        if(bbbbb==4)
        {
          buff[5]='O';
        }
        if(bbbbb==5)
        {
           buff[5]='P';
        }
        if(bbbbb==6)
        {
          buff[5]='Q';
        }
        if(bbbbb==7)
        {
          buff[5]='U';
        }
        if(bbbbb==8)
        {
          buff[5]='S';
        }   
        if(bbbbb==9)
        {
          buff[5]='T';
        }
        
        bbbbbb=bb%10;
        if(bbbbbb==0)
        {
          buff[6]='k';
        }
        if(bbbbbb==1)
        {
          buff[6]='l';
        }
        if(bbbbbb==2)
        {
          buff[6]='m';
        }
        if(bbbbbb==3)
        {
          buff[6]='n';  
        }
        if(bbbbbb==4)
        {
          buff[6]='o';
        }
        if(bbbbbb==5)
        {
           buff[6]='p';
        }
        if(bbbbbb==6)
        {
          buff[6]='q';
        }
        if(bbbbbb==7)
        {
          buff[6]='r';
        }
        if(bbbbbb==8)
        {
          buff[6]='s';
        }   
        if(bbbbbb==9)
        {
          buff[6]='t';
        }
         buff[7]='Z';
        
        // Отправка данных всем подключенным клиентам
        for (i = 0; i < MAX_SRV_CLIENTS; i++)
        {
            if (serverClients[i] && serverClients[i].connected())
            {
               serverClients[i].write(buff,s);
            }
        }        
        
        void uv();
    }

// Функция для получениязначени с датчика ультрафиолетового излучения

void uv()
{
  int uvLevel = analogRead(uv_PIN);
  int refLevel=1023;
  // Для большей точности опираемся на напряжение порта питания 3,3 В
  int outputVoltage = 3.3 / refLevel * uvLevel;
  int v;
  v=outputVoltage;
}
